package ru.amse.nikitin.protocols.app;

import ru.amse.nikitin.sensnet.impl.Mot;
import ru.amse.nikitin.sensnet.impl.WirelessPacket;
import ru.amse.nikitin.sensnet.impl.MonitoredObjectRegistry;
import ru.amse.nikitin.simulator.ELogMsgType;
import ru.amse.nikitin.simulator.impl.Logger;
import ru.amse.nikitin.simulator.impl.Time;
import ru.amse.nikitin.simulator.util.graph.IGraph;

public class SendApp extends EmptyApp {
	protected int helloCount = 1;
	protected final static Time someUnitsTime = new Time(15);
	protected final static Time oneUnitTime = new Time(0);
	
	final Runnable step = new Runnable() {
		public void run () {
			BsData data = (BsData)MonitoredObjectRegistry.getReading("temperature");
			if (data == null) {
				data = new BsData(Const.hello, ++helloCount);
			}
			WirelessPacket packet = new WirelessPacket(3, mot);
			packet.setData(data);
			if(sendMsgToLower(packet)) {
				scheduleEvent(this, someUnitsTime); // wait for next resend
				Logger.getInstance().logMessage(ELogMsgType.INFORMATION,
						"allocated " + data.getIndex());
			} else {
				scheduleEvent(this, oneUnitTime); // resend
			}
		}
		
	};
	
	private boolean sendMsgToLower(WirelessPacket packet) {
		return getGate("lower").recieveMessage(packet, this);
	}
	
	public SendApp(Mot m) {
		super(m);
	}
	public void init(IGraph<Integer> topology) {
		Logger.getInstance().logMessage(ELogMsgType.INFORMATION,
			"snd init " + mot.getID());
		step.run();
	}
}
